<script setup>
//Para recibir los props debemos declarar que atributos de nuestro elemento
//esperamos recibir como props, en este caso es title, y una vez declarado lo podremos
//usar por medio de la interpolación
//si queremos recibir varios props simplemente los agregamos a nuestro arreglo de props para recibirlos

//podemos asignar nuestra función para definir props a una constante
//y acceder a cada prop por medio de esa constante y escribiendo el nombre del
//la prop que queremos usar como si fuera un objeto
// const props=defineProps(['title', 'id', 'body', 'colorText']);
// console.log(props);
// console.log(props.title);
// console.log(props.id);

// podemos definir nuestras props como un objeto, esto nos permite además asignar tipos de datos
// a cada prop, y podemos además, asignar tambien un valor por defecto
//en caso de que no la enviemos

defineProps({
	title: String,
	id: Number,
	body: {
		type: String,
		default: 'Sin descripción',
	},
	//en este ejercicio estamos recibiendo una funcion como props
	//envez de como evento personalizado para este componente y
	//la diferencia que podemos ver esque no usamos el emit,
	//sino que la usamos como una funcion normal y esto podría parecer
	//buena idea de no ser porque estamos enviando de esta
	//forma la función completa hacia este componente
	//por lo que si nuestro componente se renderiza varias veces
	//todos nuestros componentes van a tener diferentes funciones
	//que harian lo mismo, por eso es mas recomendable enviarlo como evento personalizado
	//para no saturar la memoria de nuestra aplicación
	cambiarFavorito: Function,
});

// podemos similar a como hacemos con las props, en este caso usar la función defineEmits
//aquí declaramos los emits que vamos a recibir, podemos guardarlos en una variable, para poder
//usarlos usando esa variable, sin necesidad de usar la variable global $emits

const emit = defineEmits(['cambiarFavoritoNombre']);

// podemos además usando esta sintaxis, usar los emits en nuestro script y no solamente en nuestro template
//emit('cambiarFavoritoNombre', title)
</script>

<template>
	<div class="card">
		<div class="card-body">
			<!-- usamos v-bind para agregar dinamicamente una clase en este caso recibida como prop -->
			<!-- <h5 class="card-title" :class="`text-${colorText}`"> -->
			<h5 class="card-title">{{ id }} - {{ title }}</h5>
			<p>{{ body }}</p>
			<!-- usamos emit para emitir un evento personalizado, en este caso lleva el nombre de 
			cambiarFavorito, recibe un parametro, que en este caso es el título, esto ejecuta nuestro evento
			personalizado que enviamos desde nuestro componente padre -->
			<!-- aquí podemos ver el uso de emits sin el uso del $emits global -->

			<!-- @click="emit('cambiarFavoritoNombre', title)" -->
			<!-- en el botón ahora llamamos la función que recibimos como props
			de la moda como llamamos cualquier otra funcion -->
			<button
				@click="cambiarFavorito(title)"
				class="btn btn-outline-primary"
			>
				Favorito
			</button>
		</div>
	</div>
</template>
